{###############################################################################
# Dipesh-TxtEdit-32 Version 1.xx.xx                         Delphi 3 Quellcode #
################################################################################
# Programmiert & Entwickelt von Sebastian Sauer (Dipesh)                       #
# E-Mail: dipesh@gmx.de                                                        #
# Homepage: http://members.tripod.de/dipesh4                                   #
################################################################################
# EINSTELL.PAS - TEinstellungenForm                                            #
###############################################################################}

UNIT Einstell;

INTERFACE

Uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, Grids, IniFiles,
  RichEdit2;

Type
  TEinstellungenForm = class(TForm)
    PageControl: TPageControl;
    TabTools: TTabSheet;
    TabSpeichern: TTabSheet;
    ButtonEntfernen: TButton;
    ButtonHinzufuegen: TButton;
    ButtonOben: TButton;
    ButtonUnten: TButton;
    CheckBox_AutoSaveSettings: TCheckBox;
    CheckBox_AutoLoadSaveOpenFiles: TCheckBox;
    TabDarstellung: TTabSheet;
    CheckBox_ShowMarkleiste: TCheckBox;
    CheckBox_AutoUrl: TCheckBox;
    CheckBox_ReadOnlyFilesNurLesen: TCheckBox;
    Button_Uebernehmen: TButton;
    Button_Abbrechen: TButton;
    ToolsGrid: TStringGrid;
    ButtonLinks: TButton;
    ButtonRechts: TButton;
    CheckBox_StartWithNew: TCheckBox;
    TabAllgemein: TTabSheet;
    CheckBoxInstanz: TCheckBox;
    Label1: TLabel;
    Label2: TLabel;
    ComboBox_FilterOeffnen: TComboBox;
    ComboBox_FilterSpeichern: TComboBox;
    procedure OnCreate(Sender: TObject);
    procedure OnActivate(Sender: TObject);
    procedure OnChange(Sender: TObject);
    procedure ToolsGrid_OnSelectCell(Sender: TObject; Col, Row: Integer; var CanSelect: Boolean);
    procedure ToolsGrid_OnSetEditText(Sender: TObject; ACol, ARow: Integer; const Value: String);
    procedure ButtonHinzufuegen_OnClick(Sender: TObject);
    procedure ButtonEntfernen_OnClick(Sender: TObject);
    procedure ButtonVerschieben_OnClick(Sender: TObject);
    procedure Button_Uebernehmen_OnClick(Sender: TObject);
  end;

Var
  ToolsGridIsModified: boolean;
  AktuellToolsGridCellStr: string;
  EinstellungenForm: TEinstellungenForm;

IMPLEMENTATION

Uses Globals, Main, MainCld;

{$R *.DFM}

procedure TEinstellungenForm.OnCreate(Sender: TObject);
begin Screen.Cursor:=crHourGlass; end;

procedure TEinstellungenForm.OnActivate(Sender: TObject);
var OA_Int1: integer; OA_LstItm1: TListItem;
begin
  // Seite "Allgemein"
  CheckBoxInstanz.Checked:=SingleInstance;
  ComboBox_FilterOeffnen.Text:=MainForm.OpenDialog.Filter; ComboBox_FilterOeffnen.Items.Add(MainForm.OpenDialog.Filter);
  ComboBox_FilterSpeichern.Text:=MainForm.SaveDialog.Filter; ComboBox_FilterSpeichern.Items.Add(MainForm.SaveDialog.Filter);
  // Seite "Darstellung"
  CheckBox_ShowMarkleiste.Checked:=ShowMarkLeiste;
  CheckBox_AutoUrl.Checked:=UseAutoUrls;
  CheckBox_StartWithNew.Checked:=StartWithNewDoc;
  CheckBox_ReadOnlyFilesNurLesen.Checked:=IfReadOnlyThenNurLesenZulassen;
  // Seite "Speichern"
  CheckBox_AutoSaveSettings.Checked:=SaveSettingsOnExit;
  CheckBox_AutoLoadSaveOpenFiles.Checked:=LoadSaveOpenFiles;
  // Seite "Tools"
  ToolsGrid.Cells[0,0]:='Name/Beschreibung'; ToolsGrid.Cells[1,0]:='Befehl';
  For OA_Int1:=0 to MainForm.MainMenu_Tools.Count-1 do begin
    ToolsGrid.Cells[0,ToolsGrid.RowCount-1]:=MainForm.MainMenu_Tools.Items[OA_Int1].Caption;
    ToolsGrid.Cells[1,ToolsGrid.RowCount-1]:=MainForm.MainMenu_Tools.Items[OA_Int1].Hint;
    ToolsGrid.RowCount:=ToolsGrid.RowCount+1;
  end;
  ToolsGridIsModified:=false; Button_Uebernehmen.Enabled:=false;
  Screen.Cursor:=crDefault;
end;

procedure TEinstellungenForm.OnChange(Sender: TObject);
begin If not Button_Uebernehmen.Enabled then Button_Uebernehmen.Enabled:=true; end;

procedure TEinstellungenForm.ToolsGrid_OnSelectCell(Sender: TObject; Col, Row: Integer; var CanSelect: Boolean);
begin AktuellToolsGridCellStr:=ToolsGrid.Cells[Col,Row]; end;

procedure TEinstellungenForm.ToolsGrid_OnSetEditText(Sender: TObject; ACol, ARow: Integer; const Value: String);
begin If AktuellToolsGridCellStr<>Value then begin ToolsGridIsModified:=true; OnChange(Sender); end; end;

procedure TEinstellungenForm.ButtonHinzufuegen_OnClick(Sender: TObject);
begin ToolsGrid.RowCount:=ToolsGrid.RowCount+1; end;

procedure TEinstellungenForm.ButtonEntfernen_OnClick(Sender: TObject);
begin
  With ToolsGrid do begin If RowCount<3 then Exit;
    If (Cells[0,RowCount-1]>'')and((Cells[1,RowCount-1])>'') then OnChange(Sender); RowCount:=RowCount-1; end;
end;

procedure TEinstellungenForm.ButtonVerschieben_OnClick(Sender: TObject);
var BOOC_Col, BOOC_Row: integer; BOOC_Str1: string;
begin
  BOOC_Col:=0; BOOC_Row:=0;
  With ToolsGrid do begin
    If Sender=ButtonOben then begin If Row<2 then Exit; BOOC_Row:=-1; end else
    If Sender=ButtonUnten then begin If Row>=RowCount-1 then Exit; BOOC_Row:=+1; end else
    If Sender=ButtonLinks then begin If Col<1 then Exit; BOOC_Col:=-1; end else
    If Sender=ButtonRechts then begin If Col>0 then Exit; BOOC_Col:=+1; end else Exit;
    BOOC_Str1:=Cells[Col+BOOC_Col,Row+BOOC_Row]; Cells[Col+BOOC_Col,Row+BOOC_Row]:=Cells[Col,Row];
    Cells[Col,Row]:=BOOC_Str1; Col:=Col+BOOC_Col; Row:=Row+BOOC_Row; OnChange(Sender);
  end;
end;

procedure TEinstellungenForm.Button_Uebernehmen_OnClick(Sender: TObject);
var BUOC_Int1: integer; BUOC_IniFile: TIniFile;
begin
  Try BUOC_IniFile:=TIniFile.Create(IniFileCom);
    // Seite "Allgemein"
    SingleInstance:=CheckBoxInstanz.Checked; BUOC_IniFile.WriteBool('MainWindow','SingleInstance',SingleInstance);
    MainForm.OpenDialog.Filter:=ComboBox_FilterOeffnen.Text; BUOC_IniFile.WriteString('Open','Filter',MainForm.OpenDialog.Filter);
    MainForm.SaveDialog.Filter:=ComboBox_FilterSpeichern.Text; BUOC_IniFile.WriteString('Save','Filter',MainForm.SaveDialog.Filter);
    // Seite "Darstellung"
    ShowMarkLeiste:=CheckBox_ShowMarkleiste.Checked; BUOC_IniFile.WriteBool('View','ShowMarkbar',ShowMarkLeiste);
    UseAutoUrls:=CheckBox_AutoUrl.Checked; BUOC_IniFile.WriteBool('View','AutoUrlDetection',UseAutoUrls);
    For BUOC_Int1:=0 to MainForm.MDIChildCount-1 do begin
      If TMainChildForm(MainForm.ActiveMDIChild).RichEdit.ShowSelectionBar<>ShowMarkLeiste then TMainChildForm(MainForm.ActiveMDIChild).RichEdit.ShowSelectionBar:=ShowMarkLeiste;
      If (TMainChildForm(MainForm.ActiveMDIChild).RichEdit.AutoUrlDetect=adNone)and(UseAutoUrls) then TMainChildForm(MainForm.ActiveMDIChild).RichEdit.AutoUrlDetect:=adDefault
      else TMainChildForm(MainForm.ActiveMDIChild).RichEdit.AutoUrlDetect:=adNone;
    end;
    StartWithNewDoc:=CheckBox_StartWithNew.Checked; BUOC_IniFile.WriteBool('View','StartWithNewDoc',StartWithNewDoc);
    IfReadOnlyThenNurLesenZulassen:=CheckBox_ReadOnlyFilesNurLesen.Checked; BUOC_IniFile.WriteBool('View','OpenAsReadOnlyIfIsReadOnly',IfReadOnlyThenNurLesenZulassen);
    // Seite "Speichern"
    SaveSettingsOnExit:=CheckBox_AutoSaveSettings.Checked; BUOC_IniFile.WriteBool('Save','AutoSaveSettings',SaveSettingsOnExit);
    LoadSaveOpenFiles:=CheckBox_AutoLoadSaveOpenFiles.Checked; BUOC_IniFile.WriteBool('Save','AutoSaveOpenFiles',LoadSaveOpenFiles);
    // Seite "Tools"
    With ToolsGrid do If ToolsGridIsModified then begin
      BUOC_IniFile.EraseSection('Tools');
      For BUOC_Int1:=0 to MainForm.MainMenu_Tools.Count-1 do MainForm.MainMenu_Tools.Items[BUOC_Int1].Free;
      MainForm.MainMenu_Tools.Visible:=false;
      For BUOC_Int1:=1 to RowCount-1 do If (Cells[0,BUOC_Int1]>'')and(Cells[1,BUOC_Int1]>'') then begin
        BUOC_IniFile.WriteString('Tools',Cells[0,BUOC_Int1],Cells[1,BUOC_Int1]);
        MainForm.AddItemToToolsMenu(Cells[0,BUOC_Int1],Cells[1,BUOC_Int1]);
      end;
    end;
  Finally BUOC_IniFile.Free; end;
end;

END.
